#ifndef METHOD_H
#define METHOD_H

#include <gvc.h>
#include <assert.h>
#include <malloc.h>
#define GNU_SOURCE
#include <string.h>
#include <linkedlist.h>
#include <var.h>
#include <type.h>

typedef enum
{ positive, negative, both } scedge_t;

typedef struct sensitivity
{
  var_t *port;
  scedge_t edge;
} sensitivity_t;

typedef struct method
{
  char *name;
  int sc_method;
  Agnode_t *implementation;
  Agnode_t *block;
  type_t * returns;
  linkedlist_t *parameters;
  linkedlist_t *variables;
  linkedlist_t *sensitivity_def;
  linkedlist_t *sensitivity_pos;
  linkedlist_t *sensitivity_neg;
} method_t;

typedef struct methodn
{
  listnode_t node;
  method_t *method;
} methodn_t;

#define method_str( m ) __method_str( #m, m )

char *__method_str (char *name, method_t * m);
inline method_t *method_new (Agnode_t * root);
inline void method_free (method_t * m);

inline void
method_translate (FILE * fd, method_t * method,
		  void (*algorithim) (FILE *, method_t *));


#endif
