#ifndef TYPE_H
#define TYPE_H

#include <gvc.h>
#include <assert.h>
#include <malloc.h>
#define GNU_SOURCE
#include <string.h>
#include <linkedlist.h>
#include <util.h>


typedef struct dimensions
{
  int *dim;
  int n;
} dimensions_t;

typedef struct structdef{
  char *name;
  char *alias;
  linkedlist_t *fields;
}structdef_t;

typedef struct structn
{
  listnode_t node;
  structdef_t structdef;
}structn_t;


typedef struct type
{
  char *name;
  int template;
  char *sctype;
  structdef_t *structdef;
  dimensions_t array;
  Agnode_t *implementation;
} type_t;


typedef struct enumerator
{
  char *name;
  char *value;
} enumerator_t;

typedef struct enumeratorn
{
  listnode_t node;
  enumerator_t enumerator;
} enumeratorn_t;

typedef struct enumeration
{
  char *name;
  linkedlist_t *enumerators;
} enumeration_t;

typedef struct enumerationn
{
  listnode_t node;
  enumeration_t enumeration;
} enumerationn_t;

typedef struct alias
{
  char *name;
  char *value;
} alias_t;

typedef struct aliasn
{
  listnode_t node;
  alias_t alias;
} aliasn_t;


#define type_str( type ) __type_str( #type, type )

inline char *__type_str (char *name, type_t * type);

inline type_t *type_new (Agnode_t * root);
inline void type_free (type_t * t);

inline char *type_translate (type_t * type, char *(*algorithim) (type_t *));


#endif
