#include <var.h>
#include <util.h>

inline char *
__var_str (char *name, var_t * port)
{
  char *str;
  char *type = type_str (port->type);

  assert (port);
  assert (port->name);

  asprintf (&str, "%s = [ name = %s, type = [%s] ]", name, port->name, type);

  return str;
}

static inline void
var_load (var_t * port)
{

  char *str = get_namedattr (port->implementation, "name");
  port->name = str;

  //debug( "loading var %s", str );

  //print_ast( port->implementation );

  port->init = get_scchild (port->implementation);

  Agnode_t *type;
  type = resolve_path (port->implementation, 1, "cInstantiatedForwardType");

  if (!type)
    type = resolve_path (port->implementation, 1, "cArrayType");

  if (!type)
    type = resolve_path (port->implementation, 1, "cBuiltInType");

  if (!type)
    type = resolve_path (port->implementation, 1, "cForwardType");


  if (type)
    {
      port->type = type_new (type);
    }
  else
    {
      print_ast (port->implementation);
      panic ("can't load variable %s", str);
    }

  return;

  Agedge_t *e;
  for_child (e, port->implementation, cInstantiatedForwardType)
  {
    Agnode_t *type = e->head;

    port->type = type_new (type);

    //char *str = type_str( port->type );
    //printf( "%s", str );
    //free( str );

  }

  for_child (e, port->implementation, cArrayType)
  {
    Agnode_t *type = e->head;
    //panic( "stop for debug on %s", port->name );
    port->type = type_new (type);
    //panic( "stop for debug on %s ", str );
  }

}


inline var_t *
var_new (Agnode_t * root)
{
  var_t *p = (var_t *) malloc (sizeof (var_t));
  assert (p);

  p->implementation = root;

  var_load (p);

  return p;
}

inline void
var_free (var_t * p)
{
  assert (p);
  free (p);
  return;
}
