#include "systemc.h"

SC_MODULE( half_adder )
{

  sc_in< bool > a,b;
  sc_out<bool> sum,carry;
  sc_inout<bool> test;

  void prc_half_adder(){
    sum = test;
    sum = ( a ^ b )  & ( a ^ b );
    carry = a & (a & b);
    test = carry;
  }

  void prc_half_adder2(){
    if ( a == 1 )
      test = 2;
    else if ( b == 0 )
      test = 3;
    else
      test = test + 1;
  }

  SC_CTOR( half_adder )
    {
      SC_METHOD( prc_half_adder );
      sensitive << a << b;

      SC_METHOD( prc_half_adder2 );
      sensitive << a << b;
    }

};


SC_MODULE( full_adder ){
  sc_in<bool> a,b,cin;
  sc_out<bool> sum,cout;

  sc_signal<bool> c1,s1,c2;
  sc_signal<bool> s;

  half_adder *ha1_ptr,*ha2_ptr;

  void prc_or();

  SC_CTOR( full_adder )
    {
      ha1_ptr = new half_adder("ha1");

      ha1_ptr->a( a );
      ha1_ptr->b( b );
      ha1_ptr->sum( s1 );
      ha1_ptr->carry( c1 );

      ha2_ptr = new half_adder("ha2");

      ha2_ptr->a( s );
      ha2_ptr->b( cin );
      ha2_ptr->sum( sum );
      ha2_ptr->carry( c2 );


      SC_METHOD( prc_or );
      sensitive << c1 << c2;
    }

};
