#ifndef IMDCT_H
#define IMDCT_H
#include <systemc.h>
#include "fixed.h"
#define INIT_N36 72 //constante para indexar a tabela de cossenos, separando pelo block_type
                    //as primeiras 72 posicoes saum para block_type == 2 e N ==
                    //12, as demais sao pra block_type != 2 e N == 36

// Para saber detalhes do que este modulo deve fazer olhar o arquivo:
// /home/fenix/tex/imdct.pdf
SC_MODULE(imdct){
  sc_in<bool>          clk;
  sc_in<bool>          reset_n;
  sc_in<sc_uint<2> >   in_block_type;
  sc_in<sc_uint<32> >  data_in;   // dados de entrada
  sc_in<bool>          in_trans;  // modulo anterior informa que dado eh valido
  sc_in<bool>          out_ready; // modulo seguinte informa que esta pronteo pra receber
  sc_out<bool>         in_ready;  // informa o modulo anterior que esta pronto pra receber
  sc_out<bool>         out_trans; // informa o modulo seguinte que a dado eh valida
  sc_out<sc_uint<2> >  out_block_type;
  sc_out<sc_uint<32> > data_out;  // dados de saida
  sc_in<sc_uint<2> >   in_nch;
  sc_out<sc_uint<2> >  out_nch;
  enum state_t {read_st, proc_st, write_st, write2_st}; // estados da FSM

  state_t state;

  sc_uint<6> i;
  sc_uint<5> k;
  sc_uint<2> j;

  sc_uint<2> block_type;
  sc_uint<2> nch;
  sc_int<32> xk_fix[18]; // vetor que armazena os valores de entrada que serao usados nos calculos
  sc_int<32> fix_temp_cos; // guarda o valor retirado da ROM cosseno
  sc_uint<32> fix_temp;  // acumulador do somador
  sc_int<32> fix_data;   // valor a ser enviado para a saida

  void fsm();

  //imdct(sc_module_name mod_imdct);
  SC_CTOR(imdct)
  {
    SC_METHOD(fsm);
    sensitive_pos << clk;
  }

};
#endif
