#ifndef OVERLAP_H
#define OVERLAP_H
#include <systemc.h>
#include "overlap_buf.h"

// Estados


SC_MODULE(overlap){
  enum state_t {read_state_addr, read_state, write_state_addr, write_state, write_state_addr_w };
  // Entradas (IMDCT window)
  sc_in<bool>          clk;
  sc_in<bool>          reset_n;
  sc_in<sc_uint<32> >  data_in;
  sc_in<bool>          in_trans;
  sc_in<bool>          out_ready;
  sc_in<sc_uint<2> >   in_nch;
  
  // Saidas (reorder)
  sc_out<sc_uint<2> >  out_nch;
  sc_out<bool>         in_ready;
  sc_out<bool>         out_trans;
  sc_out<sc_uint<32> > data_out;

  // Sinais internos da maquina de estados
  sc_signal<sc_uint<2> >  nch;
  sc_signal<sc_uint<6> >  i;
  sc_signal<sc_uint<5> >  sb;
  sc_signal<bool>         ch;
  sc_signal<bool>         inverte;
  sc_signal<sc_uint<2> >  valid_ch;
  sc_signal<sc_uint<6> >  valid_sb;
  sc_signal<state_t>      state;
  sc_signal<sc_uint<32> > data_ant;
  
  sc_signal<sc_uint<32> >  a;
  // Buffer -> memória RAM
  sc_signal<sc_uint<32> > buf_in;
  sc_signal<sc_uint<32> > buf_out;
  sc_signal<sc_uint<11> > buf_addr;
  sc_signal<bool>	  buf_we;
  memoria_ram_overlap *buf0;
  
  // Maquina de estados
  void fsm();
  
  //overlap(sc_module_name mod_overlap); 
  
  
  //typedef overlap SC_CURRENT_USER_MODULE;
  //overlap::overlap(sc_module_name mod_overlap) : sc_module(mod_overlap)
  SC_CTOR( overlap )
    {
      a = 0;
      buf0 = new memoria_ram_overlap("buf0");
      buf0->clk(clk);
      buf0->in_data(buf_in);
      buf0->out_data(buf_out);
      buf0->we(buf_we);
      buf0->addr(buf_addr);
  
      SC_METHOD(fsm);
      sensitive_pos << clk;
    }

};
#endif
