// Generated by CynthVLG 2.5.1  (091704)
// Fri Mar 24 23:04:46 2006
// from window.cpp
      
module multiplier_28_32(a, b, c);

      input [31:0] a;
      input [31:0] b;
      output [31:0] c;
      reg [31:0] c;
      reg sign_b;
      reg sign_a;
      reg[30:0] abs_a;
      reg[30:0] abs_b;
      reg[28:0] aux;
      reg[61:0] abs_temp;
      reg sign_temp;
      reg[62:0] temp;

         always @(a or b)
          begin :mul
            sign_a = a[31];
            sign_b = b[31];
            if (sign_a) begin
               abs_a = -a[30:0];
            end
            else begin
               abs_a = a[30:0];
            end
            if (sign_b) begin
               abs_b = -b[30:0];
            end
            else begin
               abs_b = b[30:0];
            end
            aux = 29'd0;
            aux[27] = 1'b1;
            abs_temp = {31'b0, abs_a}*{31'b0, abs_b} + {33'b0, aux};
            sign_temp = sign_a ^ sign_b;
            if (sign_temp) begin
               temp = -{1'b0, abs_temp};
            end
            else begin
               temp = {1'b0, abs_temp};
            end
            c = temp[59:28];
         end


endmodule

      
module multiplier_16_18(a, b, c);

      input [31:0] a;
      input [17:0] b;
      output [31:0] c;
      reg [31:0] c;
      reg sign_b;
      reg sign_a;
      reg[30:0] abs_a;
      reg[16:0] abs_b;
      reg[16:0] aux;
      reg[47:0] abs_temp;
      reg sign_temp;
      reg[48:0] temp;

         always @(a or b)
          begin :mul
            sign_a = a[31];
            sign_b = b[17];
            if (sign_a) begin
               abs_a = -a[30:0];
            end
            else begin
               abs_a = a[30:0];
            end
            if (sign_b) begin
               abs_b = -b[16:0];
            end
            else begin
               abs_b = b[16:0];
            end
            aux = 17'd0;
            aux[15] = 1'b1;
            abs_temp = {17'b0, abs_a}*{31'b0, abs_b} + {31'b0, aux};
            sign_temp = sign_a ^ sign_b;
            if (sign_temp) begin
               temp = -{1'b0, abs_temp};
            end
            else begin
               temp = {1'b0, abs_temp};
            end
            c = temp[47:16];
         end


endmodule

      
//#include "syncrom.h"
module vllrom(clk, addr, out_data);

      input clk;
      input [8:0] addr;
      output [17:0] out_data;
      reg [17:0] out_data;
      reg[17:0] buff[511:0];

         always @(posedge(clk))
          begin :sync_proc
            buff[1'b0] = 18'd0;
            buff[2'd1] = 18'd262143;
            buff[3'd2] = 18'd262143;
            buff[3'd3] = 18'd262143;
            buff[4'd4] = 18'd262143;
            buff[4'd5] = 18'd262143;
            buff[4'd6] = 18'd262143;
            buff[4'd7] = 18'd262142;
            buff[5'd8] = 18'd262142;
            buff[5'd9] = 18'd262142;
            buff[5'd10] = 18'd262142;
            buff[5'd11] = 18'd262141;
            buff[5'd12] = 18'd262141;
            buff[5'd13] = 18'd262140;
            buff[5'd14] = 18'd262140;
            buff[5'd15] = 18'd262139;
            buff[6'd16] = 18'd0;
            buff[6'd17] = 18'd6;
            buff[6'd18] = 18'd7;
            buff[6'd19] = 18'd7;
            buff[6'd20] = 18'd8;
            buff[6'd21] = 18'd9;
            buff[6'd22] = 18'd10;
            buff[6'd23] = 18'd11;
            buff[6'd24] = 18'd13;
            buff[6'd25] = 18'd14;
            buff[6'd26] = 18'd16;
            buff[6'd27] = 18'd17;
            buff[6'd28] = 18'd19;
            buff[6'd29] = 18'd21;
            buff[6'd30] = 18'd24;
            buff[6'd31] = 18'd26;
            buff[7'd32] = 18'd29;
            buff[7'd33] = 18'd31;
            buff[7'd34] = 18'd35;
            buff[7'd35] = 18'd38;
            buff[7'd36] = 18'd41;
            buff[7'd37] = 18'd45;
            buff[7'd38] = 18'd49;
            buff[7'd39] = 18'd53;
            buff[7'd40] = 18'd58;
            buff[7'd41] = 18'd63;
            buff[7'd42] = 18'd68;
            buff[7'd43] = 18'd73;
            buff[7'd44] = 18'd79;
            buff[7'd45] = 18'd85;
            buff[7'd46] = 18'd91;
            buff[7'd47] = 18'd97;
            buff[7'd48] = 18'd104;
            buff[7'd49] = 18'd111;
            buff[7'd50] = 18'd117;
            buff[7'd51] = 18'd125;
            buff[7'd52] = 18'd132;
            buff[7'd53] = 18'd139;
            buff[7'd54] = 18'd147;
            buff[7'd55] = 18'd154;
            buff[7'd56] = 18'd161;
            buff[7'd57] = 18'd169;
            buff[7'd58] = 18'd176;
            buff[7'd59] = 18'd183;
            buff[7'd60] = 18'd190;
            buff[7'd61] = 18'd196;
            buff[7'd62] = 18'd202;
            buff[7'd63] = 18'd208;
            buff[8'd64] = 18'd213;
            buff[8'd65] = 18'd218;
            buff[8'd66] = 18'd222;
            buff[8'd67] = 18'd225;
            buff[8'd68] = 18'd227;
            buff[8'd69] = 18'd228;
            buff[8'd70] = 18'd228;
            buff[8'd71] = 18'd227;
            buff[8'd72] = 18'd224;
            buff[8'd73] = 18'd221;
            buff[8'd74] = 18'd215;
            buff[8'd75] = 18'd208;
            buff[8'd76] = 18'd200;
            buff[8'd77] = 18'd189;
            buff[8'd78] = 18'd177;
            buff[8'd79] = 18'd163;
            buff[8'd80] = 18'd0;
            buff[8'd81] = 18'd262017;
            buff[8'd82] = 18'd262038;
            buff[8'd83] = 18'd262061;
            buff[8'd84] = 18'd262087;
            buff[8'd85] = 18'd262115;
            buff[8'd86] = 18'd2;
            buff[8'd87] = 18'd36;
            buff[8'd88] = 18'd72;
            buff[8'd89] = 18'd111;
            buff[8'd90] = 18'd153;
            buff[8'd91] = 18'd197;
            buff[8'd92] = 18'd244;
            buff[8'd93] = 18'd294;
            buff[8'd94] = 18'd347;
            buff[8'd95] = 18'd401;
            buff[8'd96] = 18'd459;
            buff[8'd97] = 18'd519;
            buff[8'd98] = 18'd581;
            buff[8'd99] = 18'd645;
            buff[8'd100] = 18'd711;
            buff[8'd101] = 18'd779;
            buff[8'd102] = 18'd848;
            buff[8'd103] = 18'd919;
            buff[8'd104] = 18'd991;
            buff[8'd105] = 18'd1064;
            buff[8'd106] = 18'd1137;
            buff[8'd107] = 18'd1210;
            buff[8'd108] = 18'd1283;
            buff[8'd109] = 18'd1356;
            buff[8'd110] = 18'd1428;
            buff[8'd111] = 18'd1498;
            buff[8'd112] = 18'd1567;
            buff[8'd113] = 18'd1634;
            buff[8'd114] = 18'd1698;
            buff[8'd115] = 18'd1759;
            buff[8'd116] = 18'd1817;
            buff[8'd117] = 18'd1870;
            buff[8'd118] = 18'd1919;
            buff[8'd119] = 18'd1962;
            buff[8'd120] = 18'd2001;
            buff[8'd121] = 18'd2032;
            buff[8'd122] = 18'd2057;
            buff[8'd123] = 18'd2075;
            buff[8'd124] = 18'd2085;
            buff[8'd125] = 18'd2087;
            buff[8'd126] = 18'd2080;
            buff[8'd127] = 18'd2063;
            buff[9'd128] = 18'd2037;
            buff[9'd129] = 18'd2000;
            buff[9'd130] = 18'd1952;
            buff[9'd131] = 18'd1893;
            buff[9'd132] = 18'd1822;
            buff[9'd133] = 18'd1739;
            buff[9'd134] = 18'd1644;
            buff[9'd135] = 18'd1535;
            buff[9'd136] = 18'd1414;
            buff[9'd137] = 18'd1280;
            buff[9'd138] = 18'd1131;
            buff[9'd139] = 18'd970;
            buff[9'd140] = 18'd794;
            buff[9'd141] = 18'd605;
            buff[9'd142] = 18'd402;
            buff[9'd143] = 18'd185;
            buff[9'd144] = 18'd0;
            buff[9'd145] = 18'd288;
            buff[9'd146] = 18'd545;
            buff[9'd147] = 18'd814;
            buff[9'd148] = 18'd1095;
            buff[9'd149] = 18'd1388;
            buff[9'd150] = 18'd1692;
            buff[9'd151] = 18'd2006;
            buff[9'd152] = 18'd2330;
            buff[9'd153] = 18'd2663;
            buff[9'd154] = 18'd3004;
            buff[9'd155] = 18'd3351;
            buff[9'd156] = 18'd3705;
            buff[9'd157] = 18'd4063;
            buff[9'd158] = 18'd4425;
            buff[9'd159] = 18'd4788;
            buff[9'd160] = 18'd5153;
            buff[9'd161] = 18'd5517;
            buff[9'd162] = 18'd5879;
            buff[9'd163] = 18'd6237;
            buff[9'd164] = 18'd6589;
            buff[9'd165] = 18'd6935;
            buff[9'd166] = 18'd7271;
            buff[9'd167] = 18'd7597;
            buff[9'd168] = 18'd7910;
            buff[9'd169] = 18'd8209;
            buff[9'd170] = 18'd8491;
            buff[9'd171] = 18'd8755;
            buff[9'd172] = 18'd8998;
            buff[9'd173] = 18'd9219;
            buff[9'd174] = 18'd9416;
            buff[9'd175] = 18'd9585;
            buff[9'd176] = 18'd9727;
            buff[9'd177] = 18'd9838;
            buff[9'd178] = 18'd9916;
            buff[9'd179] = 18'd9959;
            buff[9'd180] = 18'd9966;
            buff[9'd181] = 18'd9935;
            buff[9'd182] = 18'd9863;
            buff[9'd183] = 18'd9750;
            buff[9'd184] = 18'd9592;
            buff[9'd185] = 18'd9389;
            buff[9'd186] = 18'd9139;
            buff[9'd187] = 18'd8840;
            buff[9'd188] = 18'd8492;
            buff[9'd189] = 18'd8092;
            buff[9'd190] = 18'd7640;
            buff[9'd191] = 18'd7134;
            buff[9'd192] = 18'd6574;
            buff[9'd193] = 18'd5959;
            buff[9'd194] = 18'd5288;
            buff[9'd195] = 18'd4561;
            buff[9'd196] = 18'd3776;
            buff[9'd197] = 18'd2935;
            buff[9'd198] = 18'd2037;
            buff[9'd199] = 18'd1082;
            buff[9'd200] = 18'd70;
            buff[9'd201] = 18'd261146;
            buff[9'd202] = 18'd260022;
            buff[9'd203] = 18'd258844;
            buff[9'd204] = 18'd257611;
            buff[9'd205] = 18'd256326;
            buff[9'd206] = 18'd254990;
            buff[9'd207] = 18'd253604;
            buff[9'd208] = 18'd0;
            buff[9'd209] = 18'd11455;
            buff[9'd210] = 18'd12980;
            buff[9'd211] = 18'd14548;
            buff[9'd212] = 18'd16155;
            buff[9'd213] = 18'd17799;
            buff[9'd214] = 18'd19478;
            buff[9'd215] = 18'd21189;
            buff[9'd216] = 18'd22929;
            buff[9'd217] = 18'd24694;
            buff[9'd218] = 18'd26482;
            buff[9'd219] = 18'd28289;
            buff[9'd220] = 18'd30112;
            buff[9'd221] = 18'd31947;
            buff[9'd222] = 18'd33791;
            buff[9'd223] = 18'd35640;
            buff[9'd224] = 18'd37489;
            buff[9'd225] = 18'd39336;
            buff[9'd226] = 18'd41176;
            buff[9'd227] = 18'd43006;
            buff[9'd228] = 18'd44821;
            buff[9'd229] = 18'd46617;
            buff[9'd230] = 18'd48390;
            buff[9'd231] = 18'd50137;
            buff[9'd232] = 18'd51853;
            buff[9'd233] = 18'd53534;
            buff[9'd234] = 18'd55178;
            buff[9'd235] = 18'd56778;
            buff[9'd236] = 18'd58333;
            buff[9'd237] = 18'd59838;
            buff[9'd238] = 18'd61289;
            buff[9'd239] = 18'd62684;
            buff[9'd240] = 18'd64019;
            buff[9'd241] = 18'd65290;
            buff[9'd242] = 18'd66494;
            buff[9'd243] = 18'd67629;
            buff[9'd244] = 18'd68692;
            buff[9'd245] = 18'd69679;
            buff[9'd246] = 18'd70590;
            buff[9'd247] = 18'd71420;
            buff[9'd248] = 18'd72169;
            buff[9'd249] = 18'd72835;
            buff[9'd250] = 18'd73415;
            buff[9'd251] = 18'd73908;
            buff[9'd252] = 18'd74313;
            buff[9'd253] = 18'd74630;
            buff[9'd254] = 18'd74856;
            buff[9'd255] = 18'd74992;
            buff[10'd256] = 18'd75038;
            buff[10'd257] = 18'd74992;
            buff[10'd258] = 18'd74856;
            buff[10'd259] = 18'd74630;
            buff[10'd260] = 18'd74313;
            buff[10'd261] = 18'd73908;
            buff[10'd262] = 18'd73415;
            buff[10'd263] = 18'd72835;
            buff[10'd264] = 18'd72169;
            buff[10'd265] = 18'd71420;
            buff[10'd266] = 18'd70590;
            buff[10'd267] = 18'd69679;
            buff[10'd268] = 18'd68692;
            buff[10'd269] = 18'd67629;
            buff[10'd270] = 18'd66494;
            buff[10'd271] = 18'd65290;
            buff[10'd272] = 18'd0;
            buff[10'd273] = 18'd199460;
            buff[10'd274] = 18'd200855;
            buff[10'd275] = 18'd202306;
            buff[10'd276] = 18'd203811;
            buff[10'd277] = 18'd205366;
            buff[10'd278] = 18'd206966;
            buff[10'd279] = 18'd208610;
            buff[10'd280] = 18'd210291;
            buff[10'd281] = 18'd212007;
            buff[10'd282] = 18'd213754;
            buff[10'd283] = 18'd215527;
            buff[10'd284] = 18'd217323;
            buff[10'd285] = 18'd219138;
            buff[10'd286] = 18'd220968;
            buff[10'd287] = 18'd222808;
            buff[10'd288] = 18'd224655;
            buff[10'd289] = 18'd226504;
            buff[10'd290] = 18'd228353;
            buff[10'd291] = 18'd230197;
            buff[10'd292] = 18'd232032;
            buff[10'd293] = 18'd233855;
            buff[10'd294] = 18'd235662;
            buff[10'd295] = 18'd237450;
            buff[10'd296] = 18'd239215;
            buff[10'd297] = 18'd240955;
            buff[10'd298] = 18'd242666;
            buff[10'd299] = 18'd244345;
            buff[10'd300] = 18'd245989;
            buff[10'd301] = 18'd247596;
            buff[10'd302] = 18'd249164;
            buff[10'd303] = 18'd250689;
            buff[10'd304] = 18'd252169;
            buff[10'd305] = 18'd253604;
            buff[10'd306] = 18'd254990;
            buff[10'd307] = 18'd256326;
            buff[10'd308] = 18'd257611;
            buff[10'd309] = 18'd258844;
            buff[10'd310] = 18'd260022;
            buff[10'd311] = 18'd261146;
            buff[10'd312] = 18'd70;
            buff[10'd313] = 18'd1082;
            buff[10'd314] = 18'd2037;
            buff[10'd315] = 18'd2935;
            buff[10'd316] = 18'd3776;
            buff[10'd317] = 18'd4561;
            buff[10'd318] = 18'd5288;
            buff[10'd319] = 18'd5959;
            buff[10'd320] = 18'd6574;
            buff[10'd321] = 18'd7134;
            buff[10'd322] = 18'd7640;
            buff[10'd323] = 18'd8092;
            buff[10'd324] = 18'd8492;
            buff[10'd325] = 18'd8840;
            buff[10'd326] = 18'd9139;
            buff[10'd327] = 18'd9389;
            buff[10'd328] = 18'd9592;
            buff[10'd329] = 18'd9750;
            buff[10'd330] = 18'd9863;
            buff[10'd331] = 18'd9935;
            buff[10'd332] = 18'd9966;
            buff[10'd333] = 18'd9959;
            buff[10'd334] = 18'd9916;
            buff[10'd335] = 18'd9838;
            buff[10'd336] = 18'd0;
            buff[10'd337] = 18'd252559;
            buff[10'd338] = 18'd252728;
            buff[10'd339] = 18'd252925;
            buff[10'd340] = 18'd253146;
            buff[10'd341] = 18'd253389;
            buff[10'd342] = 18'd253653;
            buff[10'd343] = 18'd253935;
            buff[10'd344] = 18'd254234;
            buff[10'd345] = 18'd254547;
            buff[10'd346] = 18'd254873;
            buff[10'd347] = 18'd255209;
            buff[10'd348] = 18'd255555;
            buff[10'd349] = 18'd255907;
            buff[10'd350] = 18'd256265;
            buff[10'd351] = 18'd256627;
            buff[10'd352] = 18'd256991;
            buff[10'd353] = 18'd257356;
            buff[10'd354] = 18'd257719;
            buff[10'd355] = 18'd258081;
            buff[10'd356] = 18'd258439;
            buff[10'd357] = 18'd258793;
            buff[10'd358] = 18'd259140;
            buff[10'd359] = 18'd259481;
            buff[10'd360] = 18'd259814;
            buff[10'd361] = 18'd260138;
            buff[10'd362] = 18'd260452;
            buff[10'd363] = 18'd260756;
            buff[10'd364] = 18'd261049;
            buff[10'd365] = 18'd261330;
            buff[10'd366] = 18'd261599;
            buff[10'd367] = 18'd261856;
            buff[10'd368] = 18'd262099;
            buff[10'd369] = 18'd185;
            buff[10'd370] = 18'd402;
            buff[10'd371] = 18'd605;
            buff[10'd372] = 18'd794;
            buff[10'd373] = 18'd970;
            buff[10'd374] = 18'd1131;
            buff[10'd375] = 18'd1280;
            buff[10'd376] = 18'd1414;
            buff[10'd377] = 18'd1535;
            buff[10'd378] = 18'd1644;
            buff[10'd379] = 18'd1739;
            buff[10'd380] = 18'd1822;
            buff[10'd381] = 18'd1893;
            buff[10'd382] = 18'd1952;
            buff[10'd383] = 18'd2000;
            buff[10'd384] = 18'd2037;
            buff[10'd385] = 18'd2063;
            buff[10'd386] = 18'd2080;
            buff[10'd387] = 18'd2087;
            buff[10'd388] = 18'd2085;
            buff[10'd389] = 18'd2075;
            buff[10'd390] = 18'd2057;
            buff[10'd391] = 18'd2032;
            buff[10'd392] = 18'd2001;
            buff[10'd393] = 18'd1962;
            buff[10'd394] = 18'd1919;
            buff[10'd395] = 18'd1870;
            buff[10'd396] = 18'd1817;
            buff[10'd397] = 18'd1759;
            buff[10'd398] = 18'd1698;
            buff[10'd399] = 18'd1634;
            buff[10'd400] = 18'd0;
            buff[10'd401] = 18'd260646;
            buff[10'd402] = 18'd260716;
            buff[10'd403] = 18'd260788;
            buff[10'd404] = 18'd260861;
            buff[10'd405] = 18'd260934;
            buff[10'd406] = 18'd261007;
            buff[10'd407] = 18'd261080;
            buff[10'd408] = 18'd261153;
            buff[10'd409] = 18'd261225;
            buff[10'd410] = 18'd261296;
            buff[10'd411] = 18'd261365;
            buff[10'd412] = 18'd261433;
            buff[10'd413] = 18'd261499;
            buff[10'd414] = 18'd261563;
            buff[10'd415] = 18'd261625;
            buff[10'd416] = 18'd261685;
            buff[10'd417] = 18'd261743;
            buff[10'd418] = 18'd261797;
            buff[10'd419] = 18'd261850;
            buff[10'd420] = 18'd261900;
            buff[10'd421] = 18'd261947;
            buff[10'd422] = 18'd261991;
            buff[10'd423] = 18'd262033;
            buff[10'd424] = 18'd262072;
            buff[10'd425] = 18'd262108;
            buff[10'd426] = 18'd262142;
            buff[10'd427] = 18'd29;
            buff[10'd428] = 18'd57;
            buff[10'd429] = 18'd83;
            buff[10'd430] = 18'd106;
            buff[10'd431] = 18'd127;
            buff[10'd432] = 18'd146;
            buff[10'd433] = 18'd163;
            buff[10'd434] = 18'd177;
            buff[10'd435] = 18'd189;
            buff[10'd436] = 18'd200;
            buff[10'd437] = 18'd208;
            buff[10'd438] = 18'd215;
            buff[10'd439] = 18'd221;
            buff[10'd440] = 18'd224;
            buff[10'd441] = 18'd227;
            buff[10'd442] = 18'd228;
            buff[10'd443] = 18'd228;
            buff[10'd444] = 18'd227;
            buff[10'd445] = 18'd225;
            buff[10'd446] = 18'd222;
            buff[10'd447] = 18'd218;
            buff[10'd448] = 18'd213;
            buff[10'd449] = 18'd208;
            buff[10'd450] = 18'd202;
            buff[10'd451] = 18'd196;
            buff[10'd452] = 18'd190;
            buff[10'd453] = 18'd183;
            buff[10'd454] = 18'd176;
            buff[10'd455] = 18'd169;
            buff[10'd456] = 18'd161;
            buff[10'd457] = 18'd154;
            buff[10'd458] = 18'd147;
            buff[10'd459] = 18'd139;
            buff[10'd460] = 18'd132;
            buff[10'd461] = 18'd125;
            buff[10'd462] = 18'd117;
            buff[10'd463] = 18'd111;
            buff[10'd464] = 18'd0;
            buff[10'd465] = 18'd262047;
            buff[10'd466] = 18'd262053;
            buff[10'd467] = 18'd262059;
            buff[10'd468] = 18'd262065;
            buff[10'd469] = 18'd262071;
            buff[10'd470] = 18'd262076;
            buff[10'd471] = 18'd262081;
            buff[10'd472] = 18'd262086;
            buff[10'd473] = 18'd262091;
            buff[10'd474] = 18'd262095;
            buff[10'd475] = 18'd262099;
            buff[10'd476] = 18'd262103;
            buff[10'd477] = 18'd262106;
            buff[10'd478] = 18'd262109;
            buff[10'd479] = 18'd262113;
            buff[10'd480] = 18'd262115;
            buff[10'd481] = 18'd262118;
            buff[10'd482] = 18'd262120;
            buff[10'd483] = 18'd262123;
            buff[10'd484] = 18'd262125;
            buff[10'd485] = 18'd262127;
            buff[10'd486] = 18'd262128;
            buff[10'd487] = 18'd262130;
            buff[10'd488] = 18'd262131;
            buff[10'd489] = 18'd262133;
            buff[10'd490] = 18'd262134;
            buff[10'd491] = 18'd262135;
            buff[10'd492] = 18'd262136;
            buff[10'd493] = 18'd262137;
            buff[10'd494] = 18'd262137;
            buff[10'd495] = 18'd262138;
            buff[10'd496] = 18'd262139;
            buff[10'd497] = 18'd262139;
            buff[10'd498] = 18'd262140;
            buff[10'd499] = 18'd262140;
            buff[10'd500] = 18'd262141;
            buff[10'd501] = 18'd262141;
            buff[10'd502] = 18'd262142;
            buff[10'd503] = 18'd262142;
            buff[10'd504] = 18'd262142;
            buff[10'd505] = 18'd262142;
            buff[10'd506] = 18'd262143;
            buff[10'd507] = 18'd262143;
            buff[10'd508] = 18'd262143;
            buff[10'd509] = 18'd262143;
            buff[10'd510] = 18'd262143;
            buff[10'd511] = 18'd262143;
            out_data <= buff[addr];
         end


endmodule

      
module window(clk, Reset_n, in_trans, data_in, in_nch, in_ready, MAddr, MCmd, MData, SCmdAccept, SData, SResp);

      input clk;
      input Reset_n;
      input in_trans;
      input [31:0] data_in;
      input [1:0] in_nch;
      input SCmdAccept;
      input [7:0] SData;
      input [1:0] SResp;
      output in_ready;
      reg in_ready;
      output MAddr;
      reg MAddr;
      output [2:0] MCmd;
      reg [2:0] MCmd;
      output [31:0] MData;
      reg [31:0] MData;
//    sc_out<sc_uint<2> >  out_nch;
    /*sc_out<sc_uint<32> > mula_out;
    sc_out<sc_uint<32> > mulb_out;
    sc_out<sc_uint<32> > mulc_out;

    sc_out<sc_uint<10> > mem_addr;
    sc_out<sc_uint<32> > mem_in;

    sc_out<sc_uint<32> > mem_out;
    sc_out<bool> mem_we;*/
      wire[31:0] mul_c;
    // signals bound to the rom-memory pins
      wire[17:0] vllrom_out;
    // signals bound to the memory pins
      wire[31:0] vll_out;
      /*signed*/reg[31:0] state;
      reg vll_we;
      reg[31:0] mul_a;
      reg[17:0] mul_b;
      reg[8:0] vllrom_addr;
      reg[9:0] vll_addr;
      reg[31:0] vll_in;
    //sc_signal<sc_uint<32> > vll[2][512];
      reg[3:0] i;
      reg[4:0] j;
      reg[8:0] ind;
      reg[31:0] Sj;
    //sc_signal<sc_uint<4> >  block[2];
    //sc_signal<sc_uint<5> >  valid[2];
      reg[3:0] block_0; // to avoid buffers
      reg[3:0] block_1;
      reg[4:0] valid_0; // to avoid buffers
      reg[4:0] valid_1;
      reg ch;
      reg[3:0] k;
      reg[8:0] l;
      reg[1:0] nch;
      reg[1:0] prev_nch;

         always @(i or k or j or ind or ch or Sj or l or state or mul_c or nch or in_nch or in_ready or in_trans or prev_nch or vll_we or vll_addr)
          begin :comb_sigs
            in_ready = |{1'b0, state == 32'd0};
  // Memory address and Write Enable signals is modified in combinational function assyncronous
  // I do in this way to economize 1 clock cicle in the state machine
            vll_we <= 1'd0; // disables writing by default
            vll_addr <= {9'b0, ch}*10'd512 + {1'b0, l};
            if (state == 32'd1) begin
               vll_we <= 1'd1;
               vll_addr <= {9'b0, ch}*10'd512 + (10'd32*{6'b0, ch == 1'b0 ? block_0 : block_1} + {5'b0, j});
            end
            vllrom_addr <= 9'd32*{5'b0, i} + {4'b0, j};
            if (in_ready && in_trans && j == 5'd0) begin
               nch <= in_nch;
            end
            else begin
               nch <= prev_nch;
            end
            k <= ch == 1'b0 ? block_0 + i : block_1 + i;
            if ((i & 4'd1) == 4'd0) begin
               if (j < 5'd16) begin
                  ind <= 9'd16 + {4'b0, j}; //ind=32-(16-j.read());
               end
               else begin
                  ind <= 9'd48 - {4'b0, j}; //ind=32-(j.read()-16);
               end
            end
            else begin
               if (j < 5'd16) begin
                  ind <= 9'd16 - {4'b0, j};
               end
               else begin
                  ind <= {4'b0, j} - 9'd16;
               end
            end
            l <= 9'd32*{5'b0, k} + ind;
            MAddr = 1'b0;
  //  out_nch=nch.read();
         end

         always @(posedge(clk))
          begin :fsm
            if (Reset_n == 1'b0) begin
               i <= 4'd0; //don't care
               Sj <= 32'd0; //don't care
               state <= 32'd0;
               j <= 5'd0;
               prev_nch <= 2'd0;
               ch <= 1'b0;
               block_0 <= 4'd15;
               block_1 <= 4'd15;
               valid_0 <= 5'd16;
               valid_1 <= 5'd16;
               MCmd <= 3'd0;
               mul_a <= 32'd0;
            end
            else begin
               MCmd <= 3'd0; // Keep in OCP_NULL (only OCP_WRITE in send state)
               prev_nch <= nch;
               case (state) 

                  32'd0: begin
                     if (in_trans) begin
	    // Prepare to Write in ram memory in next clock (state = read_st)
                        vll_in <= data_in;
                        state <= 32'd1;
                     end
                  end
                  
                  32'd1: begin
	    //vll[ch.read()][32*block[ch.read()].read()+j.read()] = data_in;
                     j <= j + 5'd1;
                     i <= 4'd0;
                     if (j == 5'd31) begin
                        state <= 32'd3;
                        if (ch == 1'b0) begin
                           if (valid_0) begin
                              valid_0 <= valid_0 - 5'd1;
                           end
                        end
                        else begin
                           if (valid_1) begin
                              valid_1 <= valid_1 - 5'd1;
                           end
                        end
                     end
                     else begin
                        state <= 32'd0;
                     end
                  end
                  
        // Intermadiate state to read from memory
	// Here we can read since the address was modified assincronously
                  32'd3: begin
                     state <= 32'd7;
                  end
                  
                  32'd7: begin
                     mul_b <= vllrom_out; // read from rom
                     if (ch == 1'b0) begin
                        if ({1'b0, k} >= valid_0) begin
                           mul_a <= vll_out; // read from memory
                        end
                        else begin
                           mul_a <= 32'd0;
                        end
                     end
                     else begin
                        if ({1'b0, k} >= valid_1) begin
                           mul_a <= vll_out; // read from memory
                        end
                        else begin
                           mul_a <= 32'd0;
                        end
                     end
                     state <= 32'd2;
                  end
                  
                  32'd2: begin
	  //TODO: verificar SCmdAccept
          //if( SCmdAccept.read()==1 || i.read()!=15 )
                     state <= 32'd3;
                     if (i == 4'd0) begin
                        Sj <= mul_c;
                     end
                     else begin
                        Sj <= Sj + mul_c;
                     end
                     i <= i + 4'd1;
                     if (i == 4'd15) begin
                        j <= j + 5'd1;
                        if (j == 5'd31) begin
                           if (ch == 1'b0) begin
                              block_0 <= block_0 - 4'd1;
                           end
                           else begin
                              block_1 <= block_1 - 4'd1;
                           end
                           if (nch == 2'd2) begin
                              ch <= ch + 1'b1;
                           end
                           state <= 32'd0;
                        end
                     end
                     if (i == 4'd14) begin
                        state <= 32'd4;
                     end
                  end
                  
	// Intermadiate state to read from memory
	// Here we can read since the address was modified assincronously
                  32'd4: begin
                     state <= 32'd6;
                  end
                  
                  32'd6: begin
                     mul_b <= vllrom_out; // read from rom
                     if (ch == 1'b0) begin
                        if ({1'b0, k} >= valid_0) begin
                           mul_a <= vll_out; // read from memory
                        end
                        else begin
                           mul_a <= 32'd0;
                        end
                     end
                     else begin
                        if ({1'b0, k} >= valid_1) begin
                           mul_a <= vll_out; // read from memory
                        end
                        else begin
                           mul_a <= 32'd0;
                        end
                     end
                     state <= 32'd5;
                  end
                  
                  32'd5: begin
                     MCmd <= 3'd1;
                     MData <= Sj + mul_c;
                     if ({1'b0, SCmdAccept} == 2'd1) begin
	    //printf("0x%08X\n",(int)(Sj.read() + mul_c.read()));      
                        state <= 32'd3;
                     end
                     else begin
                        state <= 32'd5;
                     end
                  end
                  
               endcase

            end
         end

//    void dump();
     /*SC_METHOD(dump);
     sensitive << mul_a << mul_b << mul_c << vll_in << vll_addr << vll_out << vll_we;*/
         vllram vll0(.clk(clk), .addr(vll_addr), .we(vll_we), .in_data(vll_in), .out_data(vll_out));

         vllrom vllrom0(.clk(clk), .addr(vllrom_addr), .out_data(vllrom_out));

         multiplier_16_18 mul0(.a(mul_a), .b(mul_b), .c(mul_c));


endmodule

