#include "dcdct.h"

void dcdct::decoder() {

  if (reset) {
    qfs_state = IDLE;
    in_ready = 1;
    out_qfs_valid = 0;
    num_coef_gen = 0;
    count_zero = 0;
    qfs = 0;
    last_ = 0;
    level_ = 0;
  }
  else {
    
    //switch (qfs_state.read()) {
    switch (qfs_state) {
      
    case IDLE:
      if (in_valid) {
	count_zero = run;
	last_ = last;
	level_ = sign ? -(int)level.r : (int)level.r;
	//level_ = sign ? -level : level;
	qfs = 0;
	qfs_state = GENERATE_ZEROS_BEFORE;
      }
      break;
      
    case GENERATE_ZEROS_BEFORE:
      if (out_qfs_ready) {
	in_ready = 0;
	if (count_zero) {
	  out_qfs_valid = 1;
	  num_coef_gen = num_coef_gen + 1;
	  count_zero = count_zero - 1;
	  qfs_state = SEND_ZEROS_BEFORE;
	}
	else {
	  qfs = level_.r;
	  //qfs = level_;
	  qfs_state = SEND_LEVEL;
	}
      }
      break;
      
    case SEND_ZEROS_BEFORE:
      if (!out_qfs_ready) {
	out_qfs_valid = 0;
	qfs_state = GENERATE_ZEROS_BEFORE;
      }
      break;
      
    case SEND_LEVEL:
      if (out_qfs_ready) {
	out_qfs_valid = 1;
	num_coef_gen = num_coef_gen + 1;
	qfs_state = FINISH;
      }
      break;
      
    case GENERATE_ZEROS_AFTER:
      if (out_qfs_ready) {
	out_qfs_valid = 1;
	num_coef_gen = num_coef_gen + 1;
	qfs_state = FINISH;
      }
      break;
      
    case FINISH:
      if (!out_qfs_ready) {
	out_qfs_valid = 0;
	if ( last_ && num_coef_gen != 0) {
	  qfs = 0;
	  qfs_state = GENERATE_ZEROS_AFTER;
	}
	else {
	  if ( last_ )
	    num_coef_gen = 0;
	  in_ready = 1;
	  qfs_state = IDLE;
	}
      }
      break;
      
    default:
      qfs_state = IDLE;
      break;
      
    } // end_switch
  } // end_if
} // decoder
